# coding: utf-8

# flake8: noqa

"""
    Qiita API v2

    ## 概要  このドキュメントではQiita API v2の仕様について説明します。  ## リクエスト  APIとの全ての通信にはHTTPSプロトコルを利用します。アクセス先のホストには、Qiitaのデータを利用する場合には `qiita.com` を利用し、Qiita Teamのデータを利用する場合には `*.qiita.com` を利用します ( `*` には所属しているTeamのIDが入ります)。  ## パラメータ  API v2へのリクエストには、GET、POST、PUT、PATCH、DELETEの5種類のHTTPメソッドを利用します。多くのAPIへのリクエストにはパラメータを含められますが、GETリクエストにパラメータを含める場合にはURIクエリを利用し、それ以外の場合にはリクエストボディを利用します。パラメータには、ページネーション用途など任意で渡すものと、投稿時の本文など必須のものが存在します。APIドキュメントには、各APIごとに送信可能なパラメータが記載されています。  ## 利用制限  認証している状態ではユーザーごとに1時間に1000回まで、認証していない状態ではIPアドレスごとに1時間に60回までリクエストを受け付けます。  ## シングルサインオンを利用中のチームについて  シングルサインオンによる認証のみを許可しているQiita Teamのチームでは、セキュリティ上の理由から、チーム別アクセストークンでのみAPIを利用したアクセスが可能です。  ## ステータスコード  200、201、204、400、401、403、404、500の8種類のステータスコードを利用します。GETまたはPATCHリクエストに対しては200を、POSTリクエストに対しては201を、PUTまたはDELETEリクエストに対しては204を返します。但し、エラーが起きた場合にはその他のステータスコードの中から適切なものを返します。  ## データ形式  APIとのデータの送受信にはJSONを利用します。JSONをリクエストボディに含める場合、リクエストのContent-Typeヘッダにapplication/jsonを指定してください。但し、GETリクエストにバラメータを含める場合にはURIクエリを利用します。また、PUTリクエストまたはDELETEリクエストに対してはレスポンスボディが返却されません。日時を表現する場合には、[ISO 8601](http://ja.wikipedia.org/wiki/ISO_8601) 形式の文字列を利用します。  ``` GET /api/v2/items?page=1&per_page=20 HTTP/1.1 ```  ## エラーレスポンス  エラーが発生した場合、エラーを表現するオブジェクトを含んだエラーレスポンスが返却されます。このオブジェクトには、エラーの内容を説明するmessageプロパティと、エラーの種類を表すtypeプロパティで構成されます。typeプロパティはエラーの種類ごとに一意な文字列で、`^[a-z0-9_]+$` というパターンで表現できます。  ``` {   \"message\": \"Not found\",   \"type\": \"not_found\" } ```  ## ページネーション  一部の配列を返すAPIでは、全ての要素を一度に返すようにはなっておらず、代わりにページを指定できるようになっています。これらのAPIには、1から始まるページ番号を表すpageパラメータと、1ページあたりに含まれる要素数を表すper_pageパラメータを指定することができます。pageの初期値は1、pageの最大値は100に設定されています。また、per_pageの初期値は20、per_pageの最大値は100に設定されています。  ページを指定できるAPIでは、[Linkヘッダ](http://tools.ietf.org/html/rfc5988) を含んだレスポンスを返します。Linkヘッダには、最初のページと最後のページへのリンクに加え、存在する場合には次のページと前のページへのリンクが含まれます。個々のリンクにはそれぞれ、first、last、next、prevという値を含んだrel属性が紐付けられます。  ``` Link: <https://qiita.com/api/v2/users?page=1>; rel=\"first\",       <https://qiita.com/api/v2/users?page=1>; rel=\"prev\",       <https://qiita.com/api/v2/users?page=3>; rel=\"next\",       <https://qiita.com/api/v2/users?page=6>; rel=\"last\" ```  また、ページを指定できるAPIでは、要素の合計数が `Total-Count` レスポンスヘッダに含まれます。  ``` Total-Count: 6 ```  ## JSON Schema  Qiita API v2では、APIのインターフェースを定義したJSON-Schemaを提供しています。このスキーマでは、APIでどのようなリソースが提供されているか、それらはどのようなプロパティを持っているか、それらがどのように表現されるか、及びどのような操作が提供されているかといった事柄が定義されています。スキーマには、次のURLでアクセスできます。  - https://qiita.com/api/v2/schema - https://qiita.com/api/v2/schema?locale=en - https://qiita.com/api/v2/schema?locale=ja 

    The version of the OpenAPI document: 0.0.1
    Contact: admin@okj.info
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from qiita.v2.api.team_api import TeamApi
from qiita.v2.api.user_api import UserApi

# import ApiClient
from qiita.v2.api_response import ApiResponse
from qiita.v2.api_client import ApiClient
from qiita.v2.configuration import Configuration
from qiita.v2.exceptions import OpenApiException
from qiita.v2.exceptions import ApiTypeError
from qiita.v2.exceptions import ApiValueError
from qiita.v2.exceptions import ApiKeyError
from qiita.v2.exceptions import ApiAttributeError
from qiita.v2.exceptions import ApiException

# import models into sdk package
from qiita.v2.models.add_group_member_request import AddGroupMemberRequest
from qiita.v2.models.authenticated_user import AuthenticatedUser
from qiita.v2.models.comment import Comment
from qiita.v2.models.create_comment_request import CreateCommentRequest
from qiita.v2.models.create_group_request import CreateGroupRequest
from qiita.v2.models.create_imported_comment_request import CreateImportedCommentRequest
from qiita.v2.models.create_item_request import CreateItemRequest
from qiita.v2.models.delete_group_member_request import DeleteGroupMemberRequest
from qiita.v2.models.get_authenticated_user_items_response_inner import GetAuthenticatedUserItemsResponseInner
from qiita.v2.models.get_authenticated_user_items_response_inner_group import GetAuthenticatedUserItemsResponseInnerGroup
from qiita.v2.models.get_authenticated_user_items_response_inner_tags_inner import GetAuthenticatedUserItemsResponseInnerTagsInner
from qiita.v2.models.get_authenticated_user_items_response_inner_team_membership import GetAuthenticatedUserItemsResponseInnerTeamMembership
from qiita.v2.models.get_authenticated_user_items_response_inner_user import GetAuthenticatedUserItemsResponseInnerUser
from qiita.v2.models.group import Group
from qiita.v2.models.group_member import GroupMember
from qiita.v2.models.issue_access_token_request import IssueAccessTokenRequest
from qiita.v2.models.issue_access_token_response import IssueAccessTokenResponse
from qiita.v2.models.item import Item
from qiita.v2.models.item_tag import ItemTag
from qiita.v2.models.item_team_membership import ItemTeamMembership
from qiita.v2.models.like_history import LikeHistory
from qiita.v2.models.update_comment_request import UpdateCommentRequest
from qiita.v2.models.update_group_request import UpdateGroupRequest
from qiita.v2.models.update_item_request import UpdateItemRequest
from qiita.v2.models.user import User
